#include "util.h"
#include "preprocess.h"

char* goto_nl(char* p) {
    for (; *p; p++) {
        if (*p == '\n' || *p == '\r') {
            if (*p == '\r' && p[1] == '\n') p++;
            break;
        }
    }
    return p;
}

char* preprocess(char* buf) {
    char* d = buf;
    for (char* p = buf; *p; p++, d++) {
    comment_check:
        if (*p == '#') {
            p = goto_nl(p+1);
            p--, d--;
            continue;
        }
        else if (*p == '/' && p[1] == '/') {
            p = goto_nl(p+2);
            p--, d--;
            continue;
        }
        else if (*p == '/' && p[1] == '*') {
            for (; *p; p++) {
                if (*p == '*' && p[1] == '/') {
                    p += 2;
                    goto comment_check;
                }
            }
            error("Unterminated C-style comment.");
        }

        *d = *p;
    }
    *d = '\n';
    d++;
    *d = '\0';
    return buf;
}
