#ifndef SHI_H_
#define SHI_H_

#ifdef __cplusplus
extern "C" {
#endif
void execute_program(const char* program);
#ifdef __cplusplus
}

#include <string>
#include <vector>
#include <tr1/unordered_map>

void compile_program(
    const char* program, char** code_out, int* size_out,
    std::tr1::unordered_map<std::string, std::vector<int>*>* const_string_out,
    std::tr1::unordered_map<std::string, std::vector<int>*>* reloc_out = 0);
#endif

#endif
