#include <assert.h>
#include <stdlib.h>
#include <string.h>

#include "../preprocess.h"

char* mstrcpy(const char* s) {
    char* r = (char*)malloc(strlen(s) + 2);
    strcpy(r, s);
    return r;
}

static void preprocess_dtr_test() {
    assert(!strcmp("hoge\n", preprocess(mstrcpy("hoge"))));
    assert(!strcmp("ho\n\n", preprocess(mstrcpy("ho//ge\n"))));
    assert(!strcmp("ho\n", preprocess(mstrcpy("ho//ge"))));
    assert(!strcmp("hoe\n\n", preprocess(mstrcpy("ho/*g*/e\n"))));
    assert(!strcmp("ho\n\n", preprocess(mstrcpy("ho#e\n"))));
}
